<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_IdName ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_IdName extends AbstractStructArrayBase
{
    /**
     * The DirectPaymentCardType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_IdName[]
     */
    public $DirectPaymentCardType;
    /**
     * Constructor method for ArrayOfJPSOAP_IdName
     * @uses ArrayOfJPSOAP_IdName::setDirectPaymentCardType()
     * @param \StructType\JPSOAP_IdName[] $directPaymentCardType
     */
    public function __construct(array $directPaymentCardType = array())
    {
        $this
            ->setDirectPaymentCardType($directPaymentCardType);
    }
    /**
     * Get DirectPaymentCardType value
     * @return \StructType\JPSOAP_IdName[]|null
     */
    public function getDirectPaymentCardType()
    {
        return $this->DirectPaymentCardType;
    }
    /**
     * This method is responsible for validating the values passed to the setDirectPaymentCardType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDirectPaymentCardType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDirectPaymentCardTypeForArrayConstraintsFromSetDirectPaymentCardType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJPSOAP_IdNameDirectPaymentCardTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_IdNameDirectPaymentCardTypeItem instanceof \StructType\JPSOAP_IdName) {
                $invalidValues[] = is_object($arrayOfJPSOAP_IdNameDirectPaymentCardTypeItem) ? get_class($arrayOfJPSOAP_IdNameDirectPaymentCardTypeItem) : sprintf('%s(%s)', gettype($arrayOfJPSOAP_IdNameDirectPaymentCardTypeItem), var_export($arrayOfJPSOAP_IdNameDirectPaymentCardTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DirectPaymentCardType property can only contain items of type \StructType\JPSOAP_IdName, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DirectPaymentCardType value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_IdName[] $directPaymentCardType
     * @return \ArrayType\ArrayOfJPSOAP_IdName
     */
    public function setDirectPaymentCardType(array $directPaymentCardType = array())
    {
        // validation for constraint: array
        if ('' !== ($directPaymentCardTypeArrayErrorMessage = self::validateDirectPaymentCardTypeForArrayConstraintsFromSetDirectPaymentCardType($directPaymentCardType))) {
            throw new \InvalidArgumentException($directPaymentCardTypeArrayErrorMessage, __LINE__);
        }
        $this->DirectPaymentCardType = $directPaymentCardType;
        return $this;
    }
    /**
     * Add item to DirectPaymentCardType value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_IdName $item
     * @return \ArrayType\ArrayOfJPSOAP_IdName
     */
    public function addToDirectPaymentCardType(\StructType\JPSOAP_IdName $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_IdName) {
            throw new \InvalidArgumentException(sprintf('The DirectPaymentCardType property can only contain items of type \StructType\JPSOAP_IdName, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DirectPaymentCardType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_IdName|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_IdName|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_IdName|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_IdName|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_IdName|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DirectPaymentCardType
     */
    public function getAttributeName()
    {
        return 'DirectPaymentCardType';
    }
}
